/// <reference types="react" />
import { EdgeAccountOptions, EdgeContext } from 'edge-core-js';
import { ParentButton } from '../../types/Branding';
import { OnComplete, OnLogin, OnNotificationPermit } from '../../types/ReduxTypes';
import { AppConfig, InitialRouteName } from './types';
interface Props {
    context: EdgeContext;
    initialRoute?: InitialRouteName;
    appId?: string;
    appName?: string;
    backgroundImage?: any;
    fontDescription?: {
        regularFontFamily: string;
        headingFontFamily?: string;
    };
    landingScreenText?: string;
    parentButton?: ParentButton;
    primaryLogo?: any;
    primaryLogoCallback?: () => void;
    accountOptions: EdgeAccountOptions;
    /**
     * Application config options
     */
    appConfig?: AppConfig;
    /**
     * Called when the user navigates back passed the initialRoute if it was set.
     */
    onComplete?: OnComplete;
    onLogin: OnLogin;
    onNotificationPermit?: OnNotificationPermit;
    recoveryLogin?: string;
    skipSecurityAlerts?: boolean;
    username?: string;
    customPermissionsFunction?: () => void;
}
export declare function LoginScreen(props: Props): JSX.Element;
export {};
