var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { asyncWaterfall, shuffleArray } from './utils';
const INFO_SERVERS = ['https://info1.edge.app', 'https://info2.edge.app'];
const DEFAULT_TIMEOUT_MS = 5000;
export function fetchWaterfall(servers, path, options, timeout = DEFAULT_TIMEOUT_MS) {
    return __awaiter(this, void 0, void 0, function* () {
        const funcs = servers.map(server => () => __awaiter(this, void 0, void 0, function* () {
            const result = yield fetch(server + '/' + path, options);
            if (typeof result !== 'object') {
                const msg = `Invalid return value ${path} in ${server}`;
                console.log(msg);
                throw new Error(msg);
            }
            return result;
        }));
        return yield asyncWaterfall(funcs, timeout);
    });
}
function multiFetch(servers, path, options, timeout = 5000) {
    return __awaiter(this, void 0, void 0, function* () {
        return yield fetchWaterfall(shuffleArray(servers), path, options, timeout);
    });
}
export const fetchInfo = (path, options, timeout) => __awaiter(void 0, void 0, void 0, function* () {
    return yield multiFetch(INFO_SERVERS, path, options, timeout);
});
